#include "metadefs.h"
#include "metaprnt.h"


void print_application_opcode ()

{

	if (language == SHORT)
		return;

 	print_assign_start ("mf_intin [0]");
	print_number (mf_intin [0]);
	print (";\x0D\x0A");

}




void print_group ()

{

	start_comment ();
	print ("Group ");
	print_number (mf_intin [1]);
	print (" preceding items");
	end_comment ();

	if (language != SHORT) {

		print_assign_start ("mf_intin [1]");
		print_number (mf_intin [1]);
		print (";\x0D\x0A");

	}

}



void print_unknown ()

{

	print_comment ("Application Dependent Opcode", TRUE);

	if (language != SHORT) {

		print_pxy (0, mf_cntrl [1] * 2, mf_ptsin, TRUE, "mf_ptsin");
		print_pxy (0, mf_cntrl [3], mf_intin, FALSE, "mf_intin");

	}

}



void print_v_write_meta ()

{

	print_function_start ("v_write_meta");
	print_n (mf_cntrl [1]);
	print (", mf_ptsin");
	print_n (mf_cntrl [3]);
	print (", mf_intin");
	print_function_finish ();

}



void print_metafile_item ()

{

	switch (language) {

		case C :
			print ("    if (is_metafile) {\x0D\x0A\x0D\x0A");
			break;

		case PASCAL :
			print ("    if is_metafile then begin\x0D\x0A\x0D\x0A");
			break;

	}

	if ((language != SHORT) && (structure != CODE))
		print ("    ");

	switch (mf_intin [0]) {

		case 10 :
			print_group ();
			break;

		case 49 :
			print_comment ("Set no line style" ,FALSE);
			break;

		case 50 :
			print_comment ("Set Attribute Shadow On", FALSE);
			break;

		case 51 :
			print_comment ("Set Attribute Shadow Off", FALSE);
			break;

		case 80 :
			print_comment ("Start Draw Area Primitive", FALSE);
			break;

		case 81 :
			print_comment ("End Draw Area Primitive", FALSE);
			break;

		default :
			print_unknown ();
			break;

	}

	if (language != SHORT) {

		print_application_opcode ();
		print_v_write_meta ();

		switch (language) {

			case C :
				print ("    }\x0D\x0A\x0D\x0A");
				break;

			case PASCAL :
				print ("    end;\x0D\x0A\x0D\x0A");
				break;

		}

	}

}



void print_v_bit_image ()

{

	print_pxy (0, mf_cntrl [1] * 2, mf_ptsin, TRUE, "pxyarray");
	print_function_start ("v_bit_image");
	print_string (5, mf_cntrl [3]-5);
	print_bool (mf_intin [0]);
	print_bool (mf_intin [1]);
	print_bool (mf_intin [2]);
	print_n (mf_intin [3]);
	print_n (mf_intin [4]);
	print_ptsin ();
	print_function_finish ();
	
}


void print_escape ()

{

	switch (mf_cntrl [5]) {

		case 2 :
			print_null_function ("v_exit_cur");
			break;

		case 3 :
			print_null_function ("v_enter_cur");
			break;

		case 20 :
			print_null_function ("v_form_adv");
			break;

		case 21 :
			print_null_function ("v_output_window");
			break;

		case 22 :
			print_null_function ("v_clear_disp_list");
			break;

		case 23 :
			print_v_bit_image ();
			break;
			
		case 99 :
			print_metafile_item ();
			break;

		default :
			start_comment ();
			print ("Illegal Escape Code (");
			print_number (mf_cntrl [5]);
			print (")");
			end_comment ();
			print ("\x0D\x0A");
			break;

	}

}



void print_v_poly (name)
BYTE *name;

{

	print_pxy (0, mf_cntrl [1] * 2, mf_ptsin, TRUE, "pxyarray");
	print_function_start (name);
	print_n (mf_cntrl [1]);
	print_ptsin ();
	print_function_finish ();

}



void print_gdp ()

{

	switch (mf_cntrl [5]) {

		case 1 :
			print_pxy (0, mf_cntrl [1] * 2, mf_ptsin, TRUE, "pxyarray");
			print_function_start ("v_bar");
			print_ptsin ();
			print_function_finish ();
			break;

		case 2 :
			print_function_start ("v_arc");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_n (mf_ptsin [6]);
			print_n (mf_intin [0]);
			print_n (mf_intin [1]);
			print_function_finish ();
			break;

		case 3 :
			print_function_start ("v_pieslice");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_n (mf_ptsin [6]);
			print_n (mf_intin [0]);
			print_n (mf_intin [1]);
			print_function_finish ();
			break;

		case 4 :
			print_function_start ("v_circle");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_width (mf_ptsin [4]);
			print_function_finish ();
			break;

		case 5 :
			print_function_start ("v_ellipse");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_width (mf_ptsin [2]);
			print_height (mf_ptsin [3]);
			print_function_finish ();
			break;

		case 6 :
			print_function_start ("v_ellarc");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_width (mf_ptsin [2]);
			print_height (mf_ptsin [3]);
			print_n (mf_intin [0]);
			print_n (mf_intin [1]);
			print_function_finish ();
			break;

		case 7 :
			print_function_start ("v_ellpie");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_width (mf_ptsin [2]);
			print_height (mf_ptsin [3]);
			print_n (mf_intin [0]);
			print_n (mf_intin [1]);
			print_function_finish ();
			break;

		case 8 :
			print_function_start ("v_rbox");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_coord (mf_ptsin [1], mf_ptsin [2]);
			print_function_finish ();
			break;

		case 9 :
			print_function_start ("v_rfbox");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_coord (mf_ptsin [1], mf_ptsin [2]);
			print_function_finish ();
			break;

		case 10 :
			print_function_start ("v_justified");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_string (2, mf_cntrl [3]);
			print_width (mf_ptsin [2]);
			print_bool (mf_intin[0]);
			print_bool (mf_intin[1]);
			print_function_finish ();
			break;

		default :
			start_comment ();
			print ("Unknown GDP (");
			print_number (mf_cntrl [5]);
			print (")");
			end_comment ();
			break;

	}

}




void print_opcode ()

{

	switch (mf_cntrl [0]) {

		case -1 :

			if (structure != FUNCTION)
				print_null_function ("v_clswk");

			break;

		case 3 :
			print_null_function ("v_clrwk");
			break;

		case 4 :
			print_null_function ("v_updwk");
			break;

		case 5 :
			print_escape ();
			break;

		case 6 :
			print_v_poly ("v_pline");
			break;

		case 7 :
			print_v_poly ("v_pmarker");
			break;

		case 8 :
			print_function_start ("v_gtext");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_string (0, mf_cntrl [3]);
			print_function_finish ();
			break;

		case 9 :
			print_v_poly ("v_fillarea");
			break;

		case 11 :
			print_gdp ();
			break;

		case 12 :
			print_one_function ("vst_height", mf_ptsin [1]);
			break;
			
		case 13 :
			print_one_function ("vst_rotation", mf_intin [0]);
			break;

		case 14 :
			print_function_start ("vs_color");
			print_n (mf_intin [0]);
			print_n (mf_intin [1]);
			print_n (mf_intin [2]);
			print_n (mf_intin [3]);
			print_function_finish ();
			break;

		case 15 :
			print_one_function ("vsl_type", mf_intin [0]);
			break;

		case 16 :
			print_one_function ("vsl_width", mf_intin [0]);
			break;

		case 17 :
			print_one_function ("vsl_color", mf_intin [0]);
			break;

		case 18 :
			print_one_function ("vsm_type", mf_intin [0]);
			break;

		case 19 :
			print_one_function ("vsm_height", mf_intin [0]);
			break;

		case 20 :
			print_one_function ("vsm_color", mf_intin [0]);
			break;

		case 21 :
			print_one_function ("vst_font", mf_intin [0]);
			break;

		case 22 :
			print_one_function ("vst_color", mf_intin [0]);
			break;

		case 23 :
			print_one_function ("vsf_interior", mf_intin [0]);
			break;

		case 24 :
			print_one_function ("vsf_style", mf_intin [0]);
			break;

		case 25 :
			print_one_function ("vsf_color", mf_intin [0]);
			break;

		case 32 :
			print_one_function ("vswr_mode", mf_intin [0]);
			break;

		case 39 :
			print_function_start ("vst_alignment");
			print_n (mf_intin [0]);
			print_n (mf_intin [1]);
			print_function_finish ();
			break;

		case 104 :
			print_function_start ("vsf_perimeter");
			print_bool (mf_intin [0]);
			print_function_finish ();
			break;

		case 106 :
			print_one_function ("vst_effects", mf_intin [0]);
			break;

		case 107 :
			print_one_function ("vst_point", mf_intin [0]);
			break;

		case 108 :
			print_function_start ("vsl_ends");
			print_n (mf_intin [0]);
			print_n (mf_intin [1]);
			print_function_finish ();
			break;

		case 112 :
			print_pxy (0, mf_cntrl [3], mf_intin, TRUE, "pxyarray");
			print_function_start ("vsf_udpat");
			print_ptsin ();
			print_function_finish ();
			break;

		case 113 :
			print_one_function ("vsl_udsty", mf_intin [0]);
			break;

		case 114 :
			print_function_start ("vr_recfl");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_coord (mf_ptsin [2], mf_ptsin [3]);
			print_function_finish ();
			break;

		case 129 :
			print_function_start ("vs_clip");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_coord (mf_ptsin [2], mf_ptsin [3]);
			print_function_finish ();
			break;

		default :
			start_comment ();
			print ("Illegal opcode (");
			print_number (mf_cntrl [0]);
			print (")");
			end_comment ();
			break;

	}

}



