
#include <stdio.h>

#include "portab.h"
#include "machine.h"
#include "dos.h"
#include "dosfnctn.h"

WORD mf_cntrl [11],
	  mf_intin [80],
	  mf_ptsin [256],
	  mf_intout [45],
	  mf_ptsout [11];

BOOLEAN source = 0;

WORD *buf_end, *buf_pos, buf_lgth, hdr_size;
WORD f_open, f_handle, file_type;
BOOLEAN fst_buf;

#define         BUF_SIZE        64   /* 2048 */
#define FROM_BEG 0

typedef union bffr {
        WORD mf[ BUF_SIZE ] ;
        BYTE txt[ 2*BUF_SIZE ] ;
} BUFFR ;

BUFFR buffer;

void print_bool (b)
BOOLEAN b;

{

	if (b)
		printf (", TRUE");

	else
		printf (", FALSE");

}



void print_string (a,b)
WORD a,b;

{	WORD i;

	
	printf (", ");
	putchar ('"');
	for (i = a;i < b; putchar (mf_intin [i++]));
	putchar ('"');

}



void print_coord (x, y)
WORD x, y;

{

	printf (", %d, %d", x, y);

}



void print_pxy (start, finish, pxy)
WORD start, finish, pxy [];

{	WORD i;

	for (i = start; i <= finish; i++)
		if (source)
			printf ("pxyarray [%d] := %d;\n", i, pxy [i]);

		else
			printf ("pxyarray [%d] = %d;\n", i, pxy [i]);

}



void print_ptsin ()

{
	printf (", pxyarray");
}




void print_function_start (fnctn)
BYTE *fnctn;

{

	printf ("%s (vdi_handle", fnctn);

}


void print_function_finish ()

{

	printf (");\n\n");

}



void print_null_function (f)
BYTE *f;

{

	print_function_start (f);
	print_function_finish ();

}



void print_n (n)
WORD n;

{
	printf (", %d", n);
}



void print_one_function (f, n)
BYTE *f;
WORD n;

{
	print_function_start (f);
	print_n (n);
	print_function_finish ();
}



void print_comment (c, last_line)
BYTE *c;
BOOLEAN last_line;

{

	if (source)
		printf ("{ %s }\n", c);

	else
		printf ("/* %s */\n", c);

	if (last_line)
		printf ("\n");
}




void print_define (s, n)
BYTE *s;
WORD n;

{
	if (source) {

		putchar ('#');
		printf ("define %s %d\n", s, n);

	} else
		printf ("%s = %d;\n", s, n);

}


void print_opcode ()

{	BYTE line [128];

	switch (mf_cntrl [0]) {

		case -1 :
			print_null_function ("v_clswk");
			break;

		case 3 :
			print_null_function ("v_clrwk");
			break;

		case 4 :
			print_null_function ("v_updwk");
			break;

		case 5 :

			switch (mf_cntrl [5]) {

				case 2 :
					print_null_function ("v_exit_cur");
					break;

				case 3 :
					print_null_function ("v_enter_cur");
					break;

				case 20 :
					print_null_function ("v_form_adv");
					break;

				case 21 :
					print_null_function ("v_output_window");
					break;

				case 22 :
					print_null_function ("v_clear_disp_list");
					break;

				case 23 :

					print_pxy (0, 3, mf_ptsin);
					print_function_start ("v_bit_image");
					print_string (5, mf_cntrl [3]-5);
					print_bool (mf_intin [0]);
					print_bool (mf_intin [1]);
					print_bool (mf_intin [2]);
 					print_n (mf_intin [3]);
					print_n (mf_intin [4]);
					print_ptsin ();
					print_function_finish ();
					break;
			
				case 99 :

					switch (mf_intin [0]) {

						case 10 :
							sprintf (line, "Group %d preceding items", mf_intin [1]);
							print_comment (line, TRUE);
							break;

						case 49 :
							print_comment ("Set no line style" ,TRUE);
							break;

						case 50 :
							print_comment ("Set Attribute Shadow On", TRUE);
							break;

						case 51 :
							print_comment ("Set Attribute Shadow Off", TRUE);
							break;

						case 80 :
							print_comment ("Start Draw Area Primitive", TRUE);
							break;

						case 81 :
							print_comment ("End Draw Area Primitive", TRUE);
							break;

						default :
							sprintf (line, "Application Operation (%d)", mf_intin [0]);
							print_comment (line, TRUE);
							break;

					}

					break;

				default :
					sprintf (line, "Illegal Escape Code (%d)", mf_cntrl [5]);
					print_comment (line, TRUE);					
					break;

			}

			break;

		case 6 :
			print_pxy (0, mf_cntrl [1] * 2, mf_ptsin);
			print_function_start ("v_pline");
			print_n (mf_cntrl [1]);
			print_ptsin ();
			print_function_finish ();
			break;

		case 7 :
			print_pxy (0, mf_cntrl [1] * 2, mf_ptsin);
			print_function_start ("v_pmarker");
			print_n (mf_cntrl [1]);
			print_ptsin ();
			print_function_finish ();
			break;

		case 8 :
			print_function_start ("v_gtext");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_string (0, mf_cntrl [3]);
			print_function_finish ();
			break;

		case 9 :
			print_pxy (0, mf_cntrl [1] * 2, mf_ptsin);
			print_function_start ("v_fillarea");
			print_n (mf_cntrl [1]);
			print_ptsin ();
			print_function_finish ();
			break;

		case 11 :

			switch (mf_cntrl [5]) {

				case 1 :
					print_pxy (0, 3, mf_ptsin);
					print_function_start ("v_bar");
					print_ptsin ();
					print_function_finish ();
					break;

				case 2 :
					print_function_start ("v_arc");
					print_coord (mf_ptsin [0], mf_ptsin [1]);
					print_n (mf_ptsin [6]);
					print_coord (mf_intin [0], mf_intin [1]);
					print_function_finish ();
					break;

				case 3 :
					print_function_start ("v_pieslice");
					print_coord (mf_ptsin [0], mf_ptsin [1]);
					print_n (mf_ptsin [6]);
					print_coord (mf_intin [0], mf_intin [1]);
					print_function_finish ();
					break;

				case 4 :
					print_function_start ("v_circle");
					print_coord (mf_ptsin [0], mf_ptsin [1]);
					print_n (mf_ptsin [4]);
					print_function_finish ();
					break;

				case 5 :
					print_function_start ("v_ellipse");
					print_coord (mf_ptsin [0], mf_ptsin [1]);
					print_coord (mf_ptsin [2], mf_ptsin [3]);
					print_function_finish ();
					break;

				case 6 :
					print_function_start ("v_ellarc");
					print_coord (mf_ptsin [0], mf_ptsin [1]);
					print_coord (mf_ptsin [2], mf_ptsin [3]);
					print_coord (mf_intin [0], mf_intin [1]);
					print_function_finish ();
					break;

				case 7 :
					print_function_start ("v_ellpie");
					print_coord (mf_ptsin [0], mf_ptsin [1]);
					print_coord (mf_ptsin [2], mf_ptsin [3]);
					print_coord (mf_intin [0], mf_intin [1]);
					print_function_finish ();
					break;

				case 8 :
					print_function_start ("v_rbox");
					print_coord (mf_ptsin [0], mf_ptsin [1]);
					print_coord (mf_ptsin [1], mf_ptsin [2]);
					print_function_finish ();
					break;

				case 9 :
					print_function_start ("v_rfbox");
					print_coord (mf_ptsin [0], mf_ptsin [1]);
					print_coord (mf_ptsin [1], mf_ptsin [2]);
					print_function_finish ();
					break;

				case 10 :
					print_function_start ("v_justified");
					print_coord (mf_ptsin [0], mf_ptsin [1]);
					print_string (2, mf_intin[3]+2);
					print_n (mf_ptsin [2]);
					print_bool (mf_intin[0]);
					print_bool (mf_intin[1]);
					print_function_finish ();
					break;

				default :
					printf (line, "Unknown GDP (%d)", mf_cntrl [5]);
					print_comment (line, TRUE);
					break;

			}

			break;

		case 12 :
			print_one_function ("vst_height", mf_ptsin [1]);
			break;
			
		case 13 :
			print_one_function ("vst_rotation", mf_intin [0]);
			break;

		case 14 :
			print_function_start ("vs_color");
			print_coord (mf_intin [0], mf_intin [1]);
			print_coord (mf_intin [2], mf_intin [3]);
			print_function_finish ();
			break;

		case 15 :
			print_one_function ("vsl_type", mf_intin [0]);
			break;

		case 16 :
			print_one_function ("vsl_width", mf_intin [0]);
			break;

		case 17 :
			print_one_function ("vsl_color", mf_intin [0]);
			break;

		case 18 :
			print_one_function ("vsm_type", mf_intin [0]);
			break;

		case 19 :
			print_one_function ("vsm_width", mf_intin [0]);
			break;

		case 20 :
			print_one_function ("vsm_color", mf_intin [0]);
			break;

		case 21 :
			print_one_function ("vst_font", mf_intin [0]);
			break;

		case 22 :
			print_one_function ("vst_color", mf_intin [0]);
			break;

		case 23 :
			print_one_function ("vst_interior", mf_intin [0]);
			break;

		case 24 :
			print_one_function ("vsf_style", mf_intin [0]);
			break;

		case 25 :
			print_one_function ("vsf_color", mf_intin [0]);
			break;

		case 32 :
			print_one_function ("vswr_mode", mf_intin [0]);
			break;

		case 39 :
			print_function_start ("vst_alignment");
			print_coord (mf_intin [0], mf_intin [1]);
			print_function_finish ();
			break;

		case 104 :
			print_function_start ("vsf_perimeter");
			print_bool (mf_intin [0]);
			print_function_finish ();
			break;

		case 106 :
			print_one_function ("vst_effects", mf_intin [0]);
			break;

		case 107 :
			print_one_function ("vst_point", mf_intin [0]);
			break;

		case 108 :
			print_one_function ("vsl_ends", mf_intin [0]);
			break;

		case 112 :
			print_pxy (0, mf_cntrl [3], mf_intin);
			print_function_start ("vsf_udpat");
			print_ptsin ();
			print_function_finish ();
			break;

		case 113 :
			print_one_function ("vsl_udsty", mf_intin [0]);
			break;

		case 114 :
			print_function_start ("vr_recfl");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_coord (mf_ptsin [2], mf_ptsin [3]);
			print_function_finish ();
			break;

		case 129 :
			print_function_start ("vs_clip");
			print_coord (mf_ptsin [0], mf_ptsin [1]);
			print_coord (mf_ptsin [2], mf_ptsin [3]);
			print_function_finish ();
			break;

		default :
			sprintf (line, "Illegal opcode (%d)", mf_cntrl [0]);
			print_comment (line, TRUE);
			break;

	}

}



/**************************************************************/
        WORD
mfread_buffer( start_byte )
WORD    start_byte ;
{
    WORD size, length ;
	 extern WORD DOS_ERR;

    fst_buf = FALSE ;
    buf_pos = &buffer.mf[ 0 ] ;
    size = sizeof( buffer ) - start_byte ;
#if I8086
    length = dos_read( f_handle, (LONG) size, ADDR( &buffer.txt[ start_byte ] ) ) ;
#endif
#if MC68K
    length = mf_read( f_handle, size, ADDR( &buffer.txt[ start_byte ] ) ) ;
#endif
    if ( DOS_ERR )
        return( FALSE ) ;
    length += start_byte ;
    buf_end = buf_pos + length / 2 ;
    return( length ) ;
} /* mfread_buffer */
 
 
 /**************************************************************/
        WORD
mf_words( count, buf )
        WORD count ;
        WORD *buf ;
{
        WORD n ;
 
        while( count )
        {
            if ( buf_pos == buf_end )
            {
                if ( !mfread_buffer( 0 ) )
                    break ;
            }
            n = buf_end - buf_pos ;
            n = ( n > count ) ? count : n ;
            count -= n ;
            while( n-- )
            {
                *buf++ = *buf_pos++ ;
            }
        }
        return( count ) ;
} /* mf_words */
 
/**************************************************************/
        WORD
mf_skip( count )
        WORD count ;
{
        WORD n ;
        while( count )
        {
            if ( buf_pos == buf_end )
            {
                if ( !mfread_buffer( 0 ) )
                    break ;
            }
            n = ( buf_end - buf_pos ) / 2 ;
            n = ( n > count ) ? count : n ;
            count -= n ;
            buf_pos += n ;
        }
        return( count ) ;
} /* mf_skip */
 
  /**************************************************************/
get_mf( get_cntrl, siz_get_intin, get_intin, siz_get_ptsin, get_ptsin )
WORD get_cntrl[], siz_get_intin, get_intin[], siz_get_ptsin, get_ptsin[] ;
{
  /* Local Declarations. */
  WORD status ;
 
  /* If a file is not open, return an error indication. */

  if ( f_open == 0 )
    return( FALSE ) ;
 
  /* Get an opcode from the metafile.  If it is an end-of-file opcode,  */
  /* return an end-of-file indication ( -1 ).  If it is an invalid opcode, */
  /* return an error indication.  Otherwise, get remaining parameters.   */

  if ( mf_words( 1, &get_cntrl [0] ) )
    return( FALSE ) ;
 
  if ( get_cntrl [0] == -1 )
    return( get_cntrl [0] ) ;
 
      if ( mf_words( 1, &get_cntrl [1] ) )
        return( FALSE ) ;
      if ( mf_words( 1, &get_cntrl [3] ) )
        return( FALSE ) ;
      if ( mf_words( 1, &get_cntrl [5] ) )
        return( FALSE ) ;
      status = TRUE ;
      if ( mf_cntrl [1] > 0 )
      {
        if ( 2*get_cntrl [1] > siz_get_ptsin )
          status |= mf_skip( 2*get_cntrl [1] ) ;
        else
          status |= mf_words( 2*get_cntrl [1], get_ptsin ) ;
      }  /* End if:  vertices captured. */
      if ( get_cntrl [3] > 0 )
      {
        if ( get_cntrl [3] > siz_get_intin )
          status |= mf_skip( get_cntrl [3] ) ;
        else
          status |= mf_words( get_cntrl [3], get_intin ) ;
      }  /* End if:  integer parameters captured. */
      return( status ) ;
 
}  /* End "get_mf". */
 
 

 

/**************************************************************/
        WORD
rewind_mf()
{	extern WORD DOS_ERR;

        if ( fst_buf )
        {
            buf_pos = &buffer.mf[ 0 ] ;
        }
        else
        {
            dos_lseek( f_handle, FROM_BEG, 0L ) ;
            if ( DOS_ERR )
                return( FALSE ) ;
            if ( !( buf_lgth = mfread_buffer( 0 ) ) )
                return( FALSE ) ;
            fst_buf = TRUE ;
        }
        mf_skip( hdr_size ) ;
        return( TRUE ) ;
} /* rewind_mf */
 
 
void reset_mf()              /* Reset metafile to start of vdi commands */
{
        rewind_mf() ;
 
        while ( !get_mf( mf_cntrl, 80, mf_intin, 256, mf_ptsin ) &&
                mf_cntrl[ 0 ] == 5 && mf_cntrl[ 5 ] == 99 )
        {
        }
 
} /* reset_mf */
 


void main (argc, argv, envp)
WORD argc;
BYTE *argv [], *envp [];

{	BYTE filename [128];
	extern WORD DOS_ERR;

	if (argv [1] != NULL) {

		if (argv [1][0] == '-') {

			switch (argv [1][1]) {

				case 'c' :
					source = 0;
					break;

				case 'p' :
					source = 1;
					break;
					
				default :
					printf ("Unknown option '%c'.\n", argv [1][1]);
					break;

			}

			if (argv[2][0] != 0)
				strcpy (filename, argv [2]);

		} else
			strcpy (filename, argv [1]);

	} else {

		printf ("File : ");
		scanf ("%s", filename);

	}

	f_handle = dos_open (ADDR (filename), 0);
	f_open = TRUE;

	if (DOS_ERR) {

		fprintf (stderr, "Can't open file %s (error %d).\n", filename, DOS_ERR);
		exit ();

	}

	mfread_buffer (0);
	hdr_size = buffer.mf [1];
	print_define ("HEADER_SIZE", hdr_size);
	print_define ("VERSION", buffer.mf [2]);
	print_define ("NDC_RC_FLAG", buffer.mf [3]);
	print_define ("MIN_X_EXTENT", buffer.mf [4]);
	print_define ("MIN_Y_EXTENT", buffer.mf [5]);
	print_define ("MAX_X_EXTENT", buffer.mf [6]);
	print_define ("MAX_Y_EXTENT", buffer.mf [7]);
	print_define ("PHYSICAL_X", buffer.mf [8]);
	print_define ("PHYSICAL_y", buffer.mf [9]);
	print_define ("LOWER_LEFT_X", buffer.mf [10]);
	print_define ("LOWER_LEFT_Y", buffer.mf [11]);
	print_define ("UPPER_RIGHT_X", buffer.mf [12]);
	print_define ("UPPER_RIGHT_Y", buffer.mf [13]);
	print_define ("BIT_IMAGE_FLAG", buffer.mf [14]);

	reset_mf ();

	while (get_mf (mf_cntrl, 80, mf_intin, 256, mf_ptsin))
		print_opcode ();

 	dos_close (f_handle);

}

